`ifndef COUNTER_ENV
`define COUNTER_ENV

class counter_env extends uvm_env;

	counter_agent agent0;
	`uvm_component_utils(counter_env)

	function new(string name, uvm_component parent);
		super.new(name,parent);
	endfunction : new

	virtual function void build();
		super.build();
		agent0=counter_agent::type_id::create("agent0",this);
	endfunction : build

	virtual function void connect();
		agent0.assign_vif(top.if0);
	endfunction : connect


endclass : counter_env 
`endif
