`ifndef RAND_SEQ
`define RAND_SEQ
///UVM_counter_with_resp0/tb_src/counter_rand_seq.svh
class rand_seq extends uvm_sequence #( counter_xactn, counter_xactn );
  // factory registration macro
   `uvm_object_utils(rand_seq)
  //`uvm_sequence_utils(rand_seq, counter_sequencer)
    // `uvm_component_utils(rand_seq)
//    `uvm_sequence_utils( rand_seq,  counter_sequencer)  
  // variables  
    
  // counter_xactn req; 
  // counter_xactn rsp; 
  //--------------------------------------------------------------------
  // new
  //--------------------------------------------------------------------   
  function new(string name = "rand_seq");
    super.new(name);
  endfunction: new
  //--------------------------------------------------------------------
  // body
  //--------------------------------------------------------------------   
  task body();
    req = counter_xactn::type_id::create("req");
    forever begin
      start_item(req);
      // The contents of the sequence item are populated between the calls to
      // start_item() and finish_item(), either through directed or randomized means.
      // assert(req.randomize()); // ** AVIOD THIS 
      if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
      //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)  
      finish_item(req);
      //`uvm_info("rand_seq", "finished_item in task body ovm_low", OVM_LOW)
    end 
  endtask: body
endclass: rand_seq
`endif
