//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : fifo
// Unit            : sequence1
// File            : sequence1.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/11
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------
`ifndef SEQUENCE0
`define SEQUENCE0
//----------------------------------------------------------------------
// sequence1
//----------------------------------------------------------------------
class sequence0 extends uvm_sequence #( counter_xactn, counter_xactn );
	// factory registration macro
	`uvm_object_utils(sequence1)

	// variables  
	counter_xactn req; 
	counter_xactn rsp; 
	//--------------------------------------------------------------------
	// new
	//--------------------------------------------------------------------   
	function new(string name = "sequence1");
		super.new(name);
	endfunction: new

	//--------------------------------------------------------------------
	// body
	//--------------------------------------------------------------------   
	task body();
		req = counter_xactn::type_id::create("req"); 
		// ---------
		req.kind = counter_pkg::CT_DONE;
		for (int i=0; i<1; i++) begin
			$display("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX %t", $time);
			`uvm_do_with(req, {this.kind == CT_DONE;} )
			//            start_item(req);
			//            // The contents of the sequence item are populated between the calls to
			//            // start_item() and finish_item(), either through directed or randomized means.
			//            req.kind = counter_pkg::CT_DONE;
			//            //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
			//            //$display("testing changes after the randomization, but prior to finish_item");    
			//            finish_item(req);
			$display("done CT_DONE %t", $time);
		end
        
		//---
		$display("WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW");
		`uvm_do_with(req, {this.kind == CT_RESET;} )
		//        start_item(req);
		//        // The contents of the sequence item are populated between the calls to
		//        // start_item() and finish_item(), either through directed or randomized means.
		//        req.kind = counter_pkg::CT_RESET;
		//        //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
		//        //$display("testing changes after the randomization, but prior to finish_item");    
		//        finish_item(req);
		//        `uvm_info("sequence1", "finished_item in task body ovm_low", OVM_LOW)
		//        //$display("sequence1 finished_item in task body");
		$display("done reset @init $t", $time);
		$display("===============================QQQQQQQQQQ++++++++++++++++++++"); 
		//        if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
		//        end
		`uvm_do_with(req, {this.kind == CT_LOAD;} )
		//        start_item(req);
		//        // The contents of the sequence item are populated between the calls to
		//        // start_item() and finish_item(), either through directed or randomized means.
		//        req.kind = counter_pkg::CT_RESET;
		//        //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
		//        //$display("testing changes after the randomization, but prior to finish_item");    
		//        finish_item(req);
		//        `uvm_info("sequence1", "finished_item in task body ovm_low", OVM_LOW)
		//        //$display("sequence1 finished_item in task body");
		$display("done load @init_ld $t", $time);
		$display("===============================ZZZZZZZZ++++++++++++++++++++"); 
		//        if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
		//        end
		`uvm_do_with(req, {this.kind == CT_DONE;} )
        
		forever begin
			$display("in the forever %t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_do(req)
			start_item(req);
			$display("post start %t, req.kind.name= %s", $time, req.kind.name);
			// The contents of the sequence item are populated between the calls to
			// start_item() and finish_item(), either through directed or randomized means.
			if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
			$display("post randomize,%t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
			//$display("testing changes after the randomization, but prior to finish_item");    
			finish_item(req);
			$display("finish, %t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_info("sequence1", "finished_item in task body ovm_low", OVM_LOW)
			$display("sequence1 finished_item in task body %t", $time);
		end 
	endtask: body
endclass: sequence0
`endif

