                    //----------------------------------------------------------------------
`ifndef SEQUENCE1B
`define SEQUENCE1B
                    //----------------------------------------------------------------------
                    // sequence1
                    //----------------------------------------------------------------------
                    class sequence1b extends ovm_sequence #( counter_xactn, counter_xactn );
                        // factory registration macro
                        `uvm_object_utils(sequence1)

                        // variables  
                        counter_xactn req; 
                        counter_xactn rsp; 
                        //--------------------------------------------------------------------
                        // new
                        //--------------------------------------------------------------------   
                        function new(string name = "sequence1");
                            super.new(name);
                        endfunction: new
                       
                        //--------------------------------------------------------------------
                        // body
                        //--------------------------------------------------------------------   
                        task body();
                            req = counter_xactn::type_id::create("req"); 
                            #1;
                            // ---------
                            req.kind = counter_pkg::CT_DONE;
                            for (int i=0; i<1; i++) begin
                                `uvm_do_with(req, {this.kind == counter_pkg::CT_DONE;} )
                                req.data=4'bZZZZ;
                                //mid_do(req); 
                                // .kind = counter_pkg::CT_DONE;
                                //            start_item(req);
                                //            // The contents of the sequence item are populated between the calls to
                                //            // start_item() and finish_item(), either through directed or randomized means.
                                //            req.kind = counter_pkg::CT_DONE;
                                //            //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
                                //            //$display("testing changes after the randomization, but prior to finish_item");    
                                //            finish_item(req);
                            end
        
                            //`uvm_do_with(req, {this.kind == CT_RESET;} )
                            //req.kind = counter_pkg::CT_RESET;
                            
                            `uvm_do_with(req, {this.kind == counter_pkg::CT_RESET;} )
                            $display("req.kind.name=%s, %d", req.kind.name, req.data);
                            req.data=4'bXXX0;
                            
                            //mid_do(req);
                            $display("after mid_do: req.kind.name=%s, %d", req.kind.name, req.data);
                            //start_item(req);
                            // The contents of the sequence item are populated between the calls to
                            // start_item() and finish_item(), either through directed or randomized means.
                            
                            //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
                            //$display("testing changes after the randomization, but prior to finish_item");    
                            //finish_item(req);
                            //`uvm_do_with(req, {this.kind == CT_LOAD;} )
                            //`uvm_do_with(req, {this.kind == CT_LOAD} )
                            // constraint_block ::= { { constraint_block_item } }
                            `uvm_do_with(req, {this.kind == counter_pkg::CT_LOAD; 
                                    this.data == 4'b1010;})
                            //req.kind = counter_pkg::CT_LOAD;
                            $display("req.kind.name=%s, %d", req.kind.name, req.data);
                            //req.data=4'b0101;
                            //mid_do(req);
                            $display("after mid_do: req.kind.name=%s, %d", req.kind.name, req.data);
                            //req.data = 4'bZZZ1;
                            `uvm_do_with(req, {this.kind == counter_pkg::CT_DONE;} )
                            $display("req.kind.name=%s, %d", req.kind.name, req.data);
                            req.data=4'b1111; 
                            //mid_do(req);
                            $display("after mid_do: req.kind.name=%s, %d", req.kind.name, req.data);
                            
                            //start_item(req);
                            // The contents of the sequence item are populated between the calls to
                            // start_item() and finish_item(), either through directed or randomized means.
                           
                            //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
                            //$display("testing changes after the randomization, but prior to finish_item");    
                            //finish_item(req);
                            //_with(req, {this.kind == CT_DONE;} )
        
                            forever begin
                                `uvm_do(req)
                                //start_item(req);
                                // The contents of the sequence item are populated between the calls to
                                // start_item() and finish_item(), either through directed or randomized means.
                                //                                if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
                                //                               
                                //                                //`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
                                //                                //$display("testing changes after the randomization, but prior to finish_item");    
                                //                                finish_item(req);
                            end 
                        endtask: body
                    endclass: sequence1b
`endif

                    