`ifndef SIMPLE_TEST
`define SIMPLE_TEST

// import counter_pkg::*;
class simple_test extends counter_base_test;

	`uvm_component_utils(simple_test)

	counter_xactn x0; // =new();

	function new(string name, uvm_component parent);
		super.new(name,parent);
	endfunction : new

	virtual function void build();
		super.build();
		//set_config_int("env_0.agent0.sequencer","count",0);
		//** uvm_resource_db#(int)::set("env_0.agent0.sequencer","count",0, this);
		// uvm_config_db#(int)::set(this, "*", "A");
		// uvm_resource_db#(int)::set("A", "*", 17, this);
		x0=counter_xactn::type_id::create("x0", this);  
	endfunction : build

	task run_phase(uvm_phase phase);
		fork
			//      begin
			//          // env_0.agent0.m_checker.counter_scoreboard(); 
			//      end
			begin 
				// ct_scen_e kind_cp; 
				phase.raise_objection(this);
				uvm_top.print_topology();
				// #1; // 00; 
				// Do reset
				$display("at begin time=%t", $time);
				//uvm_report_info ("Simple_test",
				//     "Doing reset for 10 clocks");
				// env_0.agent0.m_checker.MAX_COUNT=6; // top.MAX_COUNT_TB; 
				// env_0.agent0.m_checker.MIN_COUNT=3;
				if (!x0.randomize()) `uvm_error("MYERR", "This is a randomize error");
				x0.kind = counter_pkg::CT_WAIT;
				env_0.agent0.driver.send_to_dut(x0);
				uvm_report_info("debug", "done CT_WAIT"); 
				x0.kind = counter_pkg::CT_RESET;
				env_0.agent0.driver.send_to_dut(x0);
				// env_0.agent0.driver.reset_task(1);
				//#100; 
				uvm_report_info ("Simple_test",
				"End of reset ");
				// x0 = new();
				// void'(x0.randomize());
				// CT_LOAD, CT_RESET, CT_WAIT, CT_DONE
				x0.kind = counter_pkg::CT_LOAD;
				env_0.agent0.driver.send_to_dut(x0);
				// #100; 
				for (int i=0; i<10; i++) begin
					$display("Begin for loop at %t", $time); 
					//void'(x0.randomize());
					// $assertoff could disable randomization 
					// ap_rand: assert(x0.randomize());
					// 
					if (!x0.randomize()) `uvm_error("MYERR", "This is a randomize error");
					env_0.agent0.driver.vif.driver_cb.kind_cp<=x0.kind; // for debug
					//x0.kind = counter_pkg::CT_WAIT;
					$display(x0.convert2string());
					env_0.agent0.driver.send_to_dut(x0);
				end
				if (!x0.randomize())  `uvm_error("MYERR", "This is a randomize error");						 
				// void'(x0.randomize());
				x0.kind = counter_pkg::CT_WAIT;
				env_0.agent0.driver.send_to_dut(x0);
				#100; 
				//`message(UVM_LOW,("User activated end of simulation"))
				uvm_report_info(get_name(),"User activated end of simulation");

				phase.drop_objection(this);
//                #1000
				global_stop_request(); 
			end 
		join 
	endtask : run_phase
endclass : simple_test 
`endif
