//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : fifo
// Unit            : test1
// File            : test1.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/11
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------

`ifndef TEST1
`define TEST1

//----------------------------------------------------------------------
// test1
//----------------------------------------------------------------------
class test1 extends counter_base_test;

    // factory registration macro
    `uvm_component_utils(test1) 
    // sequence1 seq;
    //--------------------------------------------------------------------
    // new
    //-------------------------------------------------------------------- 
    function new(string name = "test1",
            uvm_component parent = null);
        super.new(name, parent);
    endfunction: new

    //--------------------------------------------------------------------
    // build
    //-------------------------------------------------------------------- 
    virtual function void build();
        super.build();
        // --- Example code ---
        // option 
        // set_config_string("env_0.agent0.sequencer","default_sequence","counter_seq1");
        // set_config_int("env_0.agent0.sequencer","count",0); // <<<<---- set to 0
        //** uvm_resource_db#(int)::set("env_0.agent0.sequencer","count",0, this); // <<<<---- set to 0
        // ../tests/test1.svh(47): No Default value for formal 'value' in task/function set.
        // uvm_config_db#(int)::set(this, "*", "A");
		// uvm_resource_db#(int)::set("A", "*", 17, this);
        set_report_verbosity_level_hier(UVM_MEDIUM);
        // sequence1 seq;  // <-- Illegal here, why?? 
        // --------------------
    endfunction: build

    //--------------------------------------------------------------------
    // run
    //-------------------------------------------------------------------- 
    virtual task run();  // test1

        sequence1 seq;
        seq = sequence1::type_id::create("seq", this);
        // ../tests/test1.svh(58): No Default value for formal 'parent' in task/function create.
        uvm_test_done.raise_objection(this);
        `uvm_info({get_type_name(),":run"}, "Starting test...", UVM_LOW)
    
        fork: fork_run
            //Connect sequence to sequencer and start
            begin 
                $display("Start m_test_sequencer %t", $time);
                seq.start(m_test_sequencer, null);
                // anoher seqx start 
            end 
            #50000;
        join_any: fork_run

        `uvm_info({get_type_name(),":run"}, "... test completed", UVM_LOW)
        uvm_test_done.drop_objection(this);
    endtask: run

endclass: test1

`endif

