//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : fifo
// Unit            : test2
// File            : test2.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/11
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------

`ifndef TEST2
`define TEST2

//----------------------------------------------------------------------
// test2
//----------------------------------------------------------------------
class test2 extends counter_base_test;

	// factory registration macro
	`uvm_component_utils(test2) 
	// sequence1 seq;
	//--------------------------------------------------------------------
	// new
	//-------------------------------------------------------------------- 
	function new(string name = "test2",
		uvm_component parent = null);
		super.new(name, parent);
	endfunction: new

	//--------------------------------------------------------------------
	// build
	//-------------------------------------------------------------------- 
	virtual function void build();
		super.build();
		// --- Example code ---
		// option 
		// set_config_string("env_0.agent0.sequencer","default_sequence","counter_seq1");
		//set_config_int("env_0.agent0.sequencer","count",0); // <<<<---- set to 0
		//** uvm_resource_db#(int)::set("env_0.agent0.sequencer","count",0, this);
		// uvm_config_db#(int)::set(this, "*", "A");
		// uvm_resource_db#(int)::set("A", "*", 17, this);
		set_report_verbosity_level_hier(UVM_MEDIUM);
		// sequence1 seq;  // <-- Illegal here, why?? 
		// --------------------
	endfunction: build

	//--------------------------------------------------------------------
	// run
	//-------------------------------------------------------------------- 
	virtual task run();

	sequence1 seq1;
	sequence2 seq2;
	seq1 = sequence1::type_id::create("seq1", this);
	seq2 = sequence2::type_id::create("seq2", this);
	uvm_test_done.raise_objection(this);
	`uvm_info({get_type_name(),":run"}, "Starting test...", UVM_LOW)
    
	fork: fork_run
		//Connect sequence to sequencer and start
		begin 
			$display("Start 1 m_test_sequencer %t", $time);
			seq1.start(m_test_sequencer, null);
			// anoher seqx start 
		end 
		begin 
			$display("Start 2 m_test_sequencer %t", $time);
			seq2.start(m_test_sequencer, null);
			// anoher seqx start 
		end 
		#50000;
	join_any: fork_run

	`uvm_info({get_type_name(),":run"}, "... test completed", UVM_LOW)
	uvm_test_done.drop_objection(this);
endtask: run

endclass: test2

`endif

