//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : fifo
// Unit            : sequence1
// File            : sequence1.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/11
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------
`ifndef SEQUENCE2
`define SEQUENCE2
//----------------------------------------------------------------------
// sequence1
//----------------------------------------------------------------------
class sequence2 extends uvm_sequence #( counter_xactn, counter_xactn );
	// factory registration macro
	 `uvm_object_utils(sequence2)
	//`uvm_sequence_utils(sequence2,counter_sequencer)
	//`uvm_component_utils(sequence2)

	// variables  
//    counter_xactn req; 
//    counter_xactn rsp; 
	//--------------------------------------------------------------------
	// new
	//--------------------------------------------------------------------   
	function new(string name = "sequence2");
		super.new(name);
	endfunction: new

	//--------------------------------------------------------------------
	// body
	//--------------------------------------------------------------------   
	task body();
		req = counter_xactn::type_id::create("req"); 
        
		forever begin
			//$display("in the forever %t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_do(req)
			start_item(req);
			// $display("post start %t, req.kind.name= %s", $time, req.kind.name);
			// The contents of the sequence item are populated between the calls to
			// start_item() and finish_item(), either through directed or randomized means.
			if (!req.randomize()) `uvm_error("MYERR", "This is a randomize error");
			req.data=4'b10ZZ; 
			// $display("post randomize,%t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_info({get_type_name(),":body"},{"Sending transaction ",req.convert2string()}, OVM_MEDIUM)
			//$display("testing changes after the randomization, but prior to finish_item");    
			finish_item(req);
			get_response(rsp);
			$display("response from seq2 %d", rsp.data); 
			$display("finish seq2, %t, req.kind.name= %s", $time, req.kind.name);
			//`uvm_info("sequence1", "finished_item in task body ovm_low", OVM_LOW)
			$display("sequence2 finished_item in task body %t", $time);
		end 
	endtask: body
endclass: sequence2
`endif

