//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : fifo
// Unit            : test1
// File            : test1.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/11
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------

`ifndef TEST1_OVRIDE
`define TEST1_OVRIDE

//----------------------------------------------------------------------
// test1
//----------------------------------------------------------------------
class test1_ovride extends counter_base_test;

	// factory registration macro
	`uvm_component_utils(test1_ovride) 
	// counter_monitor_cvg monitor_cvg;
	//counter_xactn_rand xt;
	// sequence1 seq;
	//--------------------------------------------------------------------
	// new
	//-------------------------------------------------------------------- 
	function new(string name = "test1",
		uvm_component parent = null);
		super.new(name, parent);
	endfunction: new
	
	// counter_xactn x0; 
	//--------------------------------------------------------------------
	// build
	//-------------------------------------------------------------------- 
	virtual function void build();
		super.build();
		// --- Example code ---
		// option 
		// set_config_string("env_0.agent0.sequencer","default_sequence","counter_seq1");
        
		//xt= counter_xactn_rand::type_id::create("counter_xactn_rand");
		//       set_type_override("counter_xactn", "counter_xactn_rand",1); 
		uvm_report_info("FACTORY",
		"Overriding counter_xactn with counter_xactn_rand");
		factory.set_type_override_by_type(counter_xactn::get_type(),
		counter_xactn_rand::get_type());
//		factory.set_type_override_by_name("counter_xactn", // 1/07/12
//		"counter_xactn_rand");
		factory.set_type_override_by_name("counter_monitor", // 1/07/12
		"counter_monitor_cvg");
		//  set_config_string("env_0.agent0.sequencer","default_sequence","s2p_seq1");
		//  set_config_int("env_0.agent0.sequencer","count",4);
  

		//set_config_int("env_0.agent0.sequencer","count",0); // <<<<---- set to 0
		//** uvm_resource_db#(int)::set("env_0.agent0.sequencer","count",0, this);
		// uvm_config_db#(int)::set(this, "*", "A");
		// uvm_resource_db#(int)::set("A", "*", 17, this);
		set_report_verbosity_level_hier(UVM_MEDIUM);
		// --------------------
	endfunction: build

	//--------------------------------------------------------------------
	// run
	//-------------------------------------------------------------------- 
	virtual task run();

		sequence1 seq; 
		seq = sequence1::type_id::create("seq", this);
		uvm_top.print_topology();
		uvm_test_done.raise_objection(this);
		`uvm_info({get_type_name(),":run"}, "Starting test...", UVM_LOW)
    
		fork: fork_run
			//Connect sequence to sequencer and start
			begin 
				$display("Start m_test_sequencer %t", $time);
				seq.start(m_test_sequencer, null);
				// anoher seqx start 
			end 
			#50000;
		join_any: fork_run

		`uvm_info({get_type_name(),":run"}, "... test completed", UVM_LOW)
		uvm_test_done.drop_objection(this);
	endtask: run

endclass: test1_ovride

`endif

